org.eclipse.rdf4j.sail.federation.optimizers

## Class QueryMultiJoinOptimizer

- java.lang.Object
- - org.eclipse.rdf4j.sail.federation.optimizers.QueryMultiJoinOptimizer

- All Implemented Interfaces:
    QueryOptimizer

      public class QueryMultiJoinOptimizer
      extends Object
      implements QueryOptimizer

  A query optimizer that re-orders nested Joins.
  Author:
    Arjohn Kampman, James Leigh

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `QueryMultiJoinOptimizer.JoinVisitor`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected EvaluationStatistics` | `statistics`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `QueryMultiJoinOptimizer()`
    `QueryMultiJoinOptimizer(EvaluationStatistics statistics)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `optimize(TupleExpr tupleExpr, Dataset dataset, BindingSet bindings)` Applies generally applicable optimizations: path expressions are sorted from more to less specific.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### statistics

          protected final EvaluationStatistics statistics

  - ### Constructor Detail

    - #### QueryMultiJoinOptimizer

          public QueryMultiJoinOptimizer()

    - #### QueryMultiJoinOptimizer

          public QueryMultiJoinOptimizer(EvaluationStatistics statistics)

  - ### Method Detail

    - #### optimize

          public void optimize(TupleExpr tupleExpr,
                               Dataset dataset,
                               BindingSet bindings)

      Applies generally applicable optimizations: path expressions are sorted from more to less specific.
      Specified by:
        `optimize` in interface `QueryOptimizer`
      Throws:
        `StoreException`

Copyright © 2015-2021 Eclipse Foundation. All Rights Reserved.